-- Author      : XxGadgetzxX
-- Create Date : 11/22/2014 9:35:18 AM
-- Website     : http://www.gadgetz.org
-- Email       : gadgetz@gadgetz.org

--defaults
cbtn_id = 0;			
cbtn_idP = true;
cbtn_idR = false;

strVersion = "|cFF00FF00QuestComplete|r |cFFFFFF00v1.3|r by |cFF00FF00XxGadgetzxX|r";

local aLoad = false;
local qId = -1;
local qIndex = -1;
local SNDFILE = {};
local SNDNAME = {};
local INT_MAXFILES = 13;

SNDFILE[0] = "LilGadgetz.ogg"
SNDFILE[1] = "MissionSuccess.ogg";
SNDFILE[2] = "QuestComplete.ogg";
SNDFILE[3] = "SoGood.ogg";
SNDFILE[4] = "NoSweat.ogg";
SNDFILE[5] = "Lag.ogg";
SNDFILE[6] = "KeepItUP.ogg";
SNDFILE[7] = "FDICApproved.ogg";
SNDFILE[8] = "EaslyAmuzed.ogg";
SNDFILE[9] = "Confirmed.ogg";
SNDFILE[10] = "AutoEngage.ogg";
SNDFILE[11] = "Amazonian.ogg";
SNDFILE[12] = "fanfareLong.ogg";
SNDFILE[13] = "fanfare.ogg";

SNDNAME[0] = "Lil Gadgetz"
SNDNAME[1] = "Mission Success";
SNDNAME[2] = "Quest Complete";
SNDNAME[3] = "So Good";
SNDNAME[4] = "No Sweat";
SNDNAME[5] = "Lag";
SNDNAME[6] = "KeepItUp";
SNDNAME[7] = "FDIC Approved";
SNDNAME[8] = "Easly Amused";
SNDNAME[9] = "Confirmed";
SNDNAME[10] = "Auto Engage";
SNDNAME[11] = "Amazonian";
SNDNAME[12] = "Fanfare";
SNDNAME[13] = "Fanfare Long";

Frame1:RegisterEvent("CHAT_MSG_GROUP");
Frame1:RegisterEvent("CHAT_MSG_RAID");
Frame1:RegisterEvent("CHAT_MSG_PARTY");
Frame1:RegisterEvent("CHAT_MSG_SAY");
Frame1:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
Frame1:RegisterEvent("QUEST_WATCH_UPDATE");
Frame1:RegisterEvent("ADDON_LOADED");

Frame1:SetScript("OnEvent", function(self, event, ...)
	if (event == "QUEST_WATCH_UPDATE") then		
		qIndex = select(1, ...);

		local title, level, _, _, _, complete, daily, id = GetQuestLogTitle(qIndex);
		qId = id;
	end 

	if (event == "UNIT_QUEST_LOG_CHANGED") then
		local unit = select(1, ...);	
		if (unit == "player") then
			CheckQComplete();
		end			
	end

	if(event == "ADDON_LOADED") then
		fntStrTitle:SetText(strVersion);
		if (bl_setup == nil) then						
			Frame1:Show();
		else
			Frame1:Hide();
		end

		if (aLoad == false) then 
			print(strVersion .. " Loaded. Type /qcomp for menu...");
			aLoad = true;
		end		
		LoadChecked(cbtn_id);
	end
end);

--SLASH COMMANDS
SLASH_GCOMP1 = "/qcomp";
SLASH_GCOMP2 = "/qcomp on";
SLASH_GCOMP3 = "/qcomp off";
SlashCmdList["GCOMP"] = function(msg)
        GCOMP_SlashHandler(string.lower(msg));
end
function GCOMP_SlashHandler(msg)	
	if (msg == "") then
		LoadChecked(cbtn_id);
		Frame1:Show();
		print(strVersion .. " menu screen opened...");
	end

	if (msg == "on") then
		cbtnOn:SetChecked(true);
		cbtnOff:SetChecked(false);
		cbtn_idP = true;
		print(strVersion .. " sound is on...");
	end

	if (msg == "off") then
		cbtnOff:SetChecked(true);
		cbtnOn:SetChecked(false);
		cbtn_idP = false;
		print(strVersion .. " sound is off...");
	end	
end
--SLASH COMMANDS END

--SOUND CONTROL
function QuestPlaySound(id)
	if cbtn_idP then
		if cbtn_idR then
			local x = math.random(0, INT_MAXFILES);
			PlaySoundFile("Interface\\AddOns\\QuestComplete\\Sounds\\" .. SNDFILE[x], "master");
		else
			PlaySoundFile("Interface\\AddOns\\QuestComplete\\Sounds\\" .. SNDFILE[id], "master");
		end		
	end
end
--SOUND CONTROL END

--EVENT HANDLERS
function cbtn_OnClick(id)
	if (id == 0) then
	else
		cbtn0:SetChecked(false)
	end
	if (id == 1) then
	else
		cbtn1:SetChecked(false)
	end
	if (id == 2) then
	else
		cbtn2:SetChecked(false)
	end
	if (id == 3) then
	else
		cbtn3:SetChecked(false)
	end
	if (id == 4) then
	else
		cbtn4:SetChecked(false)
	end
	if (id == 5) then
	else
		cbtn5:SetChecked(false)
	end
	if (id == 6) then
	else
		cbtn6:SetChecked(false)
	end
	if (id == 7) then
	else
		cbtn7:SetChecked(false)
	end
	if (id == 8) then
	else
		cbtn8:SetChecked(false)
	end
	if (id == 9) then
	else
		cbtn9:SetChecked(false)
	end
	if (id == 10) then
	else
		cbtn10:SetChecked(false)
	end
	if (id == 11) then
	else
		cbtn11:SetChecked(false)
	end
	if (id == 12) then
	else
		cbtn12:SetChecked(false)
	end
	if (id == 13) then
	else
		cbtn13:SetChecked(false)
	end

	cbtn_id = id;
	QuestPlaySound(id);
	LoadChecked(cbtn_id);
	print(strVersion .. " sound file [|cFFFFFF00" .. SNDNAME[id] .. "|r] selected...");
end
function cbtnP_OnClick(id)	
	if (id == 1) then
		--Set playback on
		cbtn_idP = true;
		cbtnOff:SetChecked(false);
		print(strVersion .. " sound is on...");
		QuestPlaySound(cbtn_id);
	end
	if (id == 2) then
		--Set playback off
		cbtn_idP = false;
		cbtnOn:SetChecked(false);
		print(strVersion .. " sound is off...");
	end
	LoadChecked(cbtn_id);
end
function cbtnR_OnClick(id)
	if (id == 1) then
		--Set playback on
		cbtn_idR = true;
		ChangeChecked(true);
		cbtnROff:SetChecked(false);		
		print(strVersion .. " shuffle is on...");
	end
	if (id == 2) then
		--Set playback off
		cbtn_idR = false;
		ChangeChecked(false);
		cbtnROn:SetChecked(false);		
		print(strVersion .. " shuffle is off...");
	end
	LoadChecked(cbtn_id);
end
function LoadChecked(id)
	if(id == 0) then
		cbtn0:SetChecked(true);
	end
	if(id == 1) then
		cbtn1:SetChecked(true);
	end
	if(id == 2) then
		cbtn2:SetChecked(true);
	end
	if(id == 3) then
		cbtn3:SetChecked(true);
	end
	if(id == 4) then
		cbtn4:SetChecked(true);
	end
	if(id == 5) then
		cbtn5:SetChecked(true);
	end
	if(id == 6) then
		cbtn6:SetChecked(true);
	end
	if(id == 7) then
		cbtn7:SetChecked(true);
	end
	if(id == 8) then
		cbtn8:SetChecked(true);
	end
	if(id == 9) then
		cbtn9:SetChecked(true);
	end
	if(id == 10) then
		cbtn10:SetChecked(true);
	end	
	if(id == 11) then
		cbtn11:SetChecked(true);
	end	
	if(id == 12) then
		cbtn12:SetChecked(true);
	end	
	if(id == 13) then
		cbtn13:SetChecked(true);
	end	
	if cbtn_idP then 
		cbtnOn:SetChecked(true);
	else
		cbtnOff:SetChecked(true);
	end
	if cbtn_idR then 
		cbtnROn:SetChecked(true);
	else
		cbtnROff:SetChecked(true);
	end
	ChangeChecked(cbtn_idR);
end
function ChangeChecked(bl)	
	if (bl == false) then
		cbtn0:Show();
		cbtn1:Show();
		cbtn2:Show();
		cbtn3:Show();
		cbtn4:Show();
		cbtn5:Show();
		cbtn6:Show();
		cbtn7:Show();
		cbtn8:Show();
		cbtn9:Show();
		cbtn10:Show();
		cbtn11:Show();
		cbtn12:Show();
		cbtn13:Show();
	else
		cbtn0:Hide();
		cbtn1:Hide();
		cbtn2:Hide();
		cbtn3:Hide();
		cbtn4:Hide();
		cbtn5:Hide();
		cbtn6:Hide();
		cbtn7:Hide();
		cbtn8:Hide();
		cbtn9:Hide();
		cbtn10:Hide();
		cbtn11:Hide();
		cbtn12:Hide();
		cbtn13:Hide();
	end	
end  
function btnSave_OnClick() 
	cbtn_OnClick(cbtn_id);

	if (cbtn_idP) then
		if (cbtn_idR) then
			print(strVersion .. " shuffle is on, sound files will play randomly...");			
		end
	else
		print(strVersion .. " sound is off, no sound files will be played...");
	end		

	print(strVersion .. " settings have been saved...");
	print(strVersion .. " menu screen closed...");
	Frame1:Hide();
end
--EVENT HANDLERS END

function CheckQComplete()
	--Get QuestID from Watch_Update and check against that
	--print("TESTING>>>>" .. qId);

	if (qIndex ~= -1) then	
		local title, level, _, _, _, complete, daily, id = GetQuestLogTitle(qIndex);
		--print("TESTING>>>>" .. id .. "COMPLETE>>>" .. complete);
		if (complete == 1) then
			QuestPlaySound(cbtn_id);
			qId = -1;
			qIndex = -1;
		end		
	end	
end
